.386
.model flat,stdcall
option casemap:none
;
; MSDN WAVE HELP
; -=-=-=-=-=-=-=-
; http://msdn.microsoft.com/library/default.asp?url=/library/en-us/multimed/wave_3cfj.asp
; http://www.borg.com/~jglatt/tech/lowaud.htm
; http://developer.grup.com.tr/language/cbuilder/book2/cpb/9808/cpb9881.htm
; http://mediaxw.sourceforge.net/files/tmp/Windows%20NT%20DDK%20-%20Multimedia%20Drivers.pdf
;
include windows.inc
include masm32.inc
include kernel32.inc
include user32.inc
include winmm.inc
include \RadASM\Masm\inc\debug.inc

includelib masm32.lib
includelib kernel32.lib
includelib user32.lib
includelib winmm.lib
includelib \RadASM\Masm\lib\debug.lib

WaveOutProc         PROTO hWaveOut:DWORD, uMsg:DWORD, hInstance:DWORD, Param1:DWORD, Param2:DWORD
QueueWaveData       PROTO lpWaveHeader:DWORD
PlayWave            PROTO
Main                PROTO 
LPFilter            PROTO :DWORD

m2m MACRO dst, src
     push src
     pop dst
ENDM

     MM_FMT_WAVE         equ            45564157h                ; "WAVE" in little endian
     MM_FMT_FMT          equ            20746D66h                ; "fmt " in little endian
     MM_FMT_DATA         equ            61746164h                ; "data" in little endian                            

.data
     WaveName            db "Ding.WAV",0        ; Wave File Address
     Err1                db "Wave Not Found",0
     Err2                db "Wave Format Not Found in wav",0
     Err3                db "Chunk FMT info not found in wav",0
     Err4                db "Wave Format Info Read Error",0
     Err5                db "Wave Data Area Not Found",0
     Err6                db "Failed to Open Output Device",0
     Err7                db "Failed to alloc Buffers",0
     Err8                db "Prepare Header Error",0
     
      Base  dd (1 SHL 15)      
      
      Pout1 dq 0
      Pin1  dq 0
      Pout2 dq 0
      Pin2  dq 0
      
            ; 200hz          ; 100hz           10 hz               1000 hz  Corner selection values
      A  dq 0.02769840546830 ;0.01404650652530 ;0.00142273056281 ;0.12397764071599
      B  dq 0.94460318906340 ;0.97190698694940 ;0.99715453887439 ;0.75204471856802     
     
     
.data?
     hWaveOut            dd             ?                        ; Wave Output Device Handle  
     hMMIO               dd             ?                        ; MMIO File Handle
     hEvent              dd             ?                        ; Semiphore event
     nDataLeft           dd             ?                        ; Counts to zero. (Play Data)
     LastQueued          dd             ?                        ; Double Buff indicator
     MAX_BUFFER          dd             ?                        ; Wave Buffer Max Size
           
     align 4
     WaveFormat          WAVEFORMATEX   < >
     align 4
     WaveHeader1         WAVEHDR < >
     align 4
     WaveHeader2         WAVEHDR < >

.code
start:
     finit     
     invoke Main
     invoke ExitProcess, NULL
;=========================================================================================================
Main PROC
;=========================================================================================================
LOCAL mmInfo   :MMCKINFO                                         ; Wave Info Header Struct
LOCAL mmChunk  :MMCKINFO                                         ; Wave Format info 'chunk'

xor eax, eax
mov hEvent, eax
invoke CreateEvent, NULL, NULL, NULL, NULL
mov hEvent, eax     

invoke mmioOpen, addr WaveName, NULL, MMIO_READ                  ; Open the Wav to read its data
.if( eax )                                                       ; If valid handle
   mov hMMIO, eax                                                ; Save the Handle in eax
   mov mmInfo.fccType, MM_FMT_WAVE                               ; Find "WAVE" header info
   invoke mmioDescend, hMMIO, addr mmInfo, NULL, MMIO_FINDRIFF   ; and fill the Info Structure
   .if( eax )                                                    ;  If not found
      invoke MessageBox, NULL, addr Err2, NULL, MB_OK            ; Indicate Not a wave format
      jmp @MMError                                               ;  Jmp to Error exit
   .endif                                                        ;
   mov mmChunk.ckid, MM_FMT_FMT                                  ; Find the 'fmt ' field in WAVE header
   invoke mmioDescend, hMMIO, addr mmChunk,                      ; Starting where it preveious
                              addr mmInfo, MMIO_FINDCHUNK        ; left off.
   .if( eax )                                                    ; If Chunk not found.
      invoke MessageBox, NULL, addr Err3, NULL, MB_OK            ; Indicate Chunk not found
      jmp @MMError                                               ;  Jmp to Error Exit
   .endif                                                        ;
   invoke mmioRead, hMMIO, addr WaveFormat, mmChunk.ckSize       ; Fill the Wave Format Header
   .if( eax != mmChunk.ckSize )                                  ; If not all was read in
      invoke MessageBox, NULL, addr Err4, NULL, MB_OK            ; Indicate Chunk not fully read
      jmp @MMError                                               ;  Jmp to Error Exit
   .endif                                                        ;
   invoke mmioAscend, hMMIO, addr mmChunk, NULL                  ; Step back out "ascend" back
   mov mmChunk.ckid, MM_FMT_DATA                                 ; Now locate the wave Data area
   invoke mmioDescend, hMMIO, addr mmChunk,                      ; Goto the Data starting Point
                              addr mmInfo, MMIO_FINDCHUNK        ;
   .if( eax )                                                    ; If data not found
      invoke MessageBox, NULL, addr Err5, NULL, MB_OK            ; Indicate Data area not found
      jmp @MMError                                               ;  Jmp to Error Exit
   .endif                                                        ;
                                                                 ;
   m2m nDataLeft, mmChunk.ckSize                                 ; Copy the Total Bytes in Data area
   invoke PlayWave                                               ; Call the Play Fundtion
   invoke mmioClose, hMMIO, NULL                                 ; Close the File handle
.else
   invoke MessageBox, NULL, addr Err1, NULL, MB_OK               ; Indicate missing name     
   jmp @MMError                                                  ;  Jmp to Error Exit
.endif
invoke CloseHandle, hEvent
xor eax, eax                                                     ; EAX - 0
ret                                                              ; Exit Successfully

@MMError:
   invoke mmioClose, hMMIO, NULL                                 ; Close the IO Read Handle
   invoke CloseHandle, hEvent
   xor eax, eax                                                  ; EAX = 0
   dec eax                                                       ; EAX = -1
   ret                                                           ; Exit
Main ENDP


;=========================================================================================================
WaveOutProc PROC hWOut:DWORD, uMsg:DWORD, hInstance:DWORD, Param1:DWORD, Param2:DWORD
;           This is called by windows every time that some event needs to be handled by the program.
;========================================================================================================= 
     .if( uMsg == MM_WOM_DONE)                                   ; test to see if finished playing
          invoke QueueWaveData, Param1                           ; Queue more Wave Data or exit 
          .if( eax )                                             ; If finished or error
             invoke SetEvent, hEvent
          .endif
     .endif  
     ret
WaveOutProc ENDP

;=========================================================================================================
QueueWaveData PROC USES EBX lpWaveHeader:DWORD
;             Queues another buffer of data in the passed WAVEHDR.  If not finished, it returns 0.
;             If finished and no more buffers need to be queued, it returns 1.  On any error it 
;             returns -1 (0FFFFFFFFh).
;=========================================================================================================
mov ebx, lpWaveHeader                                            ; Set EBX = HeaderPointer
.if( nDataLeft )                                                 ; If still 'wave' data left to play
   mov eax, nDataLeft                                            ; get Data left to play
   .if( eax < MAX_BUFFER )                                       ; If less than one buffer
      invoke mmioRead, hMMIO, [ebx].WAVEHDR.lpData, nDataLeft    ; Read the remaining wave data into buff
      .if( eax != nDataLeft )                                    ; If not all read!
          jmp @WaveError                                         ;  Goto the Wave Error
      .endif                                                     ;
      mov [ebx].WAVEHDR.dwBufferLength, eax                      ; Else, set the # left to play
      mov LastQueued, ebx                                        ; Update the Last Queued Header/Buffer
      xor eax, eax                                               ; EAX == 0
      mov nDataLeft, eax                                         ; Indicate All done to future Queue's
      jmp @WaveQueue                                             ; Jmp to Queue the buffer
   .endif                                                        ;
   invoke mmioRead, hMMIO, [ebx].WAVEHDR.lpData, MAX_BUFFER      ; Read another Buffer's worth
   .if( eax != MAX_BUFFER )                                      ; If not all got read
      jmp @WaveError                                             ;  Goto the Wave Error
   .endif                                                        ;
   mov eax, MAX_BUFFER
   sub nDataLeft, eax                                            ; Update Data remaining to readin
   jmp @WaveQueue                                                ; Jmp to Queue the buffer
                                                                 ;
.elseif( ebx == LastQueued )                                     ; See if end was indicated
   xor eax, eax                                                  ; EAX = 0
   inc eax                                                       ; EAX = 1
   ret                                                           ; Indicate Finished
.endif                                                           ;
xor eax, eax                                                     ; Indicate Not Finished
ret                                                              ; Exit

@WaveQueue:                                                      ;
   invoke LPFilter, ebx
   invoke waveOutWrite, hWaveOut, ebx, sizeof WAVEHDR            ; Queue the next buffer of data
   xor eax, eax                                                  ; EAX = 0
   ret                                                           ; Return Not Finished.

@WaveError:                                                      ; Wave error exit
   invoke waveOutPause, hWaveOut                                 ; Stop the play back
   xor eax, eax                                                  ; EAX == 0
   dec eax                                                       ; EAX == -1
   ret                                                           ; Exit with ERROR!
QueueWaveData ENDP


;=========================================================================================================
PlayWave    PROC
;           Play the wave to an output device. WaveFormat and nDataLenght must be set!
;=========================================================================================================
invoke waveOutOpen, addr hWaveOut, WAVE_MAPPER, addr WaveFormat, ; Open an wave output device
                    offset WaveOutProc, NULL, CALLBACK_FUNCTION  ; and use the callback handler
.if( eax )
   invoke MessageBox, NULL, addr Err6, NULL, MB_OK               ; Indicate Device Error
   ret                                                           ; Exit
.endif

mov eax, WaveFormat.nAvgBytesPerSec                              ; Get bytes per second for this wave
shl eax, 1                                                       ; Bytes every 2 seconds
mov MAX_BUFFER, eax                                              ; Set Max Buffer to 2 Seconds of bytes
shl eax, 1                                                       ; size for two 2 sec buffers
invoke VirtualAlloc, 0, eax, MEM_COMMIT, PAGE_READWRITE          ; Allocate 1 Big buffer area
.if(!eax)
   invoke MessageBox, NULL, addr Err7, NULL, MB_OK               ; Indicate Device Error
   jmp @PWErr1                                                   ; Jump to Play Wave Error 1
.endif
mov WaveHeader1.lpData, eax                                      ; set the Buffer 1 pointer
add eax, MAX_BUFFER                                              ; Goto midpoint of alloc data
mov WaveHeader2.lpData, eax                                      ; Set the Buffer 2 pointer
mov eax, MAX_BUFFER                                              ; Get Max buffer length
mov WaveHeader1.dwBufferLength, eax                              ; Set it to Buffer 1
mov WaveHeader2.dwBufferLength, eax                              ; Set it to Buffer 2

invoke waveOutPrepareHeader, hWaveOut, addr WaveHeader1, SIZEOF WAVEHDR
.if( eax )
   invoke MessageBox, NULL, addr Err8, NULL, MB_OK
   jmp @PWErr2
.endif
invoke waveOutPrepareHeader, hWaveOut, addr WaveHeader2, SIZEOF WAVEHDR
.if( eax )
   invoke MessageBox, NULL, addr Err8, NULL, MB_OK
   jmp @PWErr3
.endif    

invoke QueueWaveData, addr WaveHeader1
invoke QueueWaveData, addr WaveHeader2
.if( eax != -1 )
   invoke WaitForSingleObject, hEvent, INFINITE
.endif

invoke waveOutReset, hWaveOut                                    ; Reset Playback of Wave
invoke waveOutUnprepareHeader, hWaveOut, addr WaveHeader2, SIZEOF WAVEHDR
@PWErr3:
invoke waveOutUnprepareHeader, hWaveOut, addr WaveHeader1, SIZEOF WAVEHDR
@PWErr2:
mov eax, MAX_BUFFER
shl eax, 1
invoke VirtualFree, WaveHeader1.lpData, eax, MEM_FREE
@PWErr1:
invoke waveOutClose, hWaveOut
xor eax, eax
ret

PlayWave ENDP

;==================================================================================
LPFilter PROC uses ebx esi edi lpHdr:DWORD
   mov ebx, lpHdr
   mov esi, [ebx].WAVEHDR.lpData                      ; Get the start address of data
   mov ecx, [ebx].WAVEHDR.dwBufferLength              ; Get # of bytes to process
   shr ecx, 2                                         ; div by 2 chanels and 2 byts/chanel
StartTickCount
   .while (SDWORD PTR ecx >= 0)
 
   fild SWORD PTR [esi]                               ; Left Channel Data 16 bits
   fild DWORD PTR Base                                ; Normalize it
   fdiv 
   fld  st(0)                                         ; Copy for Pin (prev input) update l8r on
   fmul QWORD PTR A                                   ; 1) In * A
   fld  QWORD PTR Pin1                                ; 2) PrevIn * A
   fmul QWORD PTR A                                   ;
   fld  QWORD PTR Pout1                               ; 3) PrevOut * B
   fmul QWORD PTR B                                   ;
   fadd
   fadd                                               ; St0 = In*A + PrevIn*A + PrevOut*B
   fxch                                               ; 
   fstp QWORD PTR Pin1                                ; Update the Prev In, pop
   fst  QWORD PTR Pout1                               ; Update PrevOut with output
   fild DWORD PTR Base                                ; Load base again
   fmul                                               ; Denormalize
   fistp SWORD PTR [esi]                              ; pop 16 bit sword == Output
 
   add esi,2                                          ; Goto Right Channel
   fild SWORD PTR [esi]
   fild DWORD PTR Base
   fdiv 
   fld  st(0)
   fmul QWORD PTR A
   fld  QWORD PTR Pin2                                ; RIght PRev In
   fmul QWORD PTR A
   fld  QWORD PTR Pout2                               ; Right Prev Out
   fmul QWORD PTR B
   fadd
   fadd
   fxch
   fstp QWORD PTR Pin2
   fst  QWORD PTR Pout2
   fild DWORD PTR Base
   fmul
   fistp SWORD PTR [esi]
   add esi,2
   dec ecx
   .endw
StopTickCount
   ret
LPFilter ENDP   
end start
end
